Subject: Re: linux-next: [DOCS] build warning after merge of the tip tree

From: Mauro Carvalho Chehab <[email-masked]>
Date: Fri, 23 Jan 2026 08:11:26 +0100

On Thu, 22 Jan 2026 17:06:28 -0800
Randy Dunlap <[email-masked]> wrote:

> + linux-doc + Jon
> 
> On 1/7/26 2:10 PM, Randy Dunlap wrote:
> > 
> > 
> > On 1/7/26 1:54 PM, Peter Zijlstra wrote:  
> >> On Wed, Jan 07, 2026 at 04:15:48PM +1100, Stephen Rothwell wrote:  
> >>> Hi all,
> >>>
> >>> After merging the tip tree, today's linux-next build (htmldocs) produced
> >>> this warning:
> >>>
> >>> Documentation/core-api/kref:328: include/linux/kref.h:72: WARNING: Invalid C declaration: Expected end of definition. [error at 96]
> >>>   int kref_put_mutex (struct kref *kref, void (*release)(struct kref *kref), str
> >>> uct mutex *mutex) __cond_acquires(true# mutex)
> >>>   ------------------------------------------------------------------------------------------------^
> >>> Documentation/core-api/kref:328: include/linux/kref.h:94: WARNING: Invalid C declaration: Expected end of definition. [error at 92]
> >>>   int kref_put_lock (struct kref *kref, void (*release)(struct kref *kref), spinlock_t *lock) __cond_acquires(true# lock)
> >>>   --------------------------------------------------------------------------------------------^
> >>>
> >>> Introduced by commit
> >>>
> >>>   5e256db9325e ("kref: Add context-analysis annotations")  
> >>
> >> I really have no clue what that thing is on about. The code is fine and
> >> works as intended.
> >>
> >> My go-to fix for anything kdoc is to change '/**' into '/*' until it
> >> goes away.  
> > 
> > Yes, that works.
> > 
> > I think that kernel-doc is just confused by the trailing __cond_acquires(true# lock).
> > 
> > Mauro, would you take a look, please?  
> We can trivially ignore "__cond_acquires(.*)" in kernel-doc to
> eliminate such build warnings.
> 
> Is that sufficient? Sure.
> Is it the right thing to do? IDK.
> Comments?

This fix sounds right to me. If not there at the patch,
I would improve the include/linux/kref.h documentation to 
describe __cond_requires() inside the kernel-doc documentation
(or at kref.rst).

> 
> ~Randy
> ---
>  tools/lib/python/kdoc/kdoc_parser.py |    1 +
>  1 file changed, 1 insertion(+)
> 
> --- a/tools/lib/python/kdoc/kdoc_parser.py
> +++ b/tools/lib/python/kdoc/kdoc_parser.py
> @@ -186,6 +186,7 @@ function_xforms  = [
>      (KernRe(r"__sched +"), ""),
>      (KernRe(r"_noprof"), ""),
>      (KernRe(r"__always_unused *"), ""),
> +    (KernRe(r"__cond_acquires\s*\(.*\)"), ""),

Regex here is too broad, as it is greedy: it may drop more
than expected. Perhaps:

    (KernRe(r"__cond_acquires\s*\([^\)]*\)"), ""),

With that, feel free to add:

	Reviewed-by: Mauro Carvalho Chehab <[email-masked]>

>      (KernRe(r"__printf\s*\(\s*\d*\s*,\s*\d*\s*\) +"), ""),
>      (KernRe(r"__(?:re)?alloc_size\s*\(\s*\d+\s*(?:,\s*\d+\s*)?\) +"), ""),
>      (KernRe(r"__diagnose_as\s*\(\s*\S+\s*(?:,\s*\d+\s*)*\) +"), ""),
> 

Thanks,
Mauro